Option Strict Off
Option Explicit On

Friend Class LSA_Access
    Inherits System.Windows.Forms.Form
    '/***********************************************************************/
    '/*                                                                     */
    '/*     IF-80  API_Test  for Visual Basic .net 2008                     */
    '/*       Interface    USB / RS-232C			                    	*/
    '/*                                                                     */
    '/*     Copyright(c) 2014  TEXIO TECHNOLOGY CORPORATION                 */
    '/***********************************************************************/

    Public DeviceId As Integer 'Device Handle
    Public IF_Sel As Short 'IF_select 0:close,1:USB,2:COM1
    Public res As Integer 'return Value
    Public flg As Integer 'return Value
    Public PcAddr As Integer 'PC Addr


    Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click 'device OPEN/CLOSE

        If Command1.Text = "OPEN" Then 'device OPEN
            Select Case (Combo1.Text)
                Case "USB"
                    IF_Sel = IF_USB
                Case "COM"
                    IF_Sel = IF_COM1
            End Select

            PcAddr = Val(Combo2.Text)
            DeviceId = LSA_DeviceOpen(PcAddr)

            If DeviceId > 0 Then
                res = LSA_Send(PcAddr, C_OUT_OFF)
                Command1.Text = "CLOSE"
                Command2.Enabled = True
                Command2.Text = "ON"
                Command3.Enabled = True
                Command4.Enabled = True
                Command5.Enabled = True
                Command6.Enabled = True
                Command7.Enabled = True
                Text1.Text = ""
            Else
                Text1.Text = " Device Open ERR"
            End If
        Else 'device close
            Command2.Text = "ON"
            Command2.BackColor = System.Drawing.SystemColors.Control
            res = LSA_Send(PcAddr, C_OUT_OFF)
            res = LSA_Send(PcAddr, C_REMOTE_OFF)

            res = LSA_DeviceClose(PcAddr)

            Command1.Text = "OPEN"
            Command2.Enabled = False
            Command3.Enabled = False
            Command4.Enabled = False
            Command5.Enabled = False
            Command6.Enabled = False
            Command7.Enabled = False
            Text1.Text = ""
            IF_Sel = 0
        End If
    End Sub

    Private Sub Command2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command2.Click 'OUTPUT On/Off
        If Command2.Text = "ON" Then
            Command2.Text = "OFF"
            res = LSA_Send(PcAddr, C_OUT_ON)
            Command2.BackColor = System.Drawing.Color.Red
        Else
            Command2.Text = "ON"
            res = LSA_Send(PcAddr, C_OUT_OFF)
            Command2.BackColor = System.Drawing.SystemColors.Control
        End If
    End Sub

    Private Sub Command3_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command3.Click 'Preset 1 call
        res = LSA_Send(PcAddr, C_PRESET & "1")
    End Sub

    Private Sub Command4_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command4.Click 'Preset 2 call
        res = LSA_Send(PcAddr, C_PRESET & "2")
    End Sub

    Private Sub Command5_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command5.Click 'Preset 3 call
        res = LSA_Send(PcAddr, C_PRESET & "3")
    End Sub

    Private Sub Command6_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command6.Click 'Preset Off
        res = LSA_Send(PcAddr, C_PRESET & "4")
    End Sub

    Private Sub Command7_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command7.Click 'Request Monitoring Value
        Dim bbuf As String

        bbuf = Space(64)
        res = LSA_Send(PcAddr, C_READBACK)
        res = LSA_Recive(PcAddr, 64, bbuf)
        Text1.Text = bbuf.Replace(vbCrLf, "") + "A"
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub Combo1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo1.SelectedIndexChanged
        If Combo1.Text = "COM" Then
            Label4.Text = "COM PORT"
        Else
            Label4.Text = "PC ADDR"
        End If
    End Sub

    Private Sub LSA_Access_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load 'Form Load
        Dim index As Short

        Combo1.Items.Add(("USB"))
        Combo1.Items.Add(("COM"))
        For index = 1 To 30
            Combo2.Items.Add((Str(index)))

        Next index
    End Sub

    Private Sub LSA_Access_FormClosing(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim Cancel As Boolean = eventArgs.Cancel
        Dim UnloadMode As System.Windows.Forms.CloseReason = eventArgs.CloseReason 'Form Close(x Button)
        If IF_Sel <> 0 Then
            res = LSA_Send(PcAddr, C_OUT_OFF)
            res = LSA_Send(PcAddr, C_REMOTE_OFF)
            res = LSA_DeviceClose(PcAddr)
        End If
        eventArgs.Cancel = Cancel
    End Sub

    '/***********************************************************************/
    '/*     IF-80  Interface Select                                         */
    '/***********************************************************************/

    Private Function LSA_DeviceOpen(ByRef addr As Integer) As Integer

        Select Case (IF_Sel)
            Case IF_USB
                LSA_DeviceOpen = USB488_DeviceOpen(addr)

            Case IF_COM1
                SerialPort1.PortName = "COM" & Trim(Str(PcAddr))
                SerialPort1.Open()

                LSA_DeviceOpen = 1

        End Select
    End Function

    Private Function LSA_DeviceClose(ByRef addr As Integer) As Integer

        Select Case (IF_Sel)
            Case IF_USB
                LSA_DeviceClose = USB488_DeviceClose(addr)

            Case IF_COM1
                SerialPort1.Close()
                LSA_DeviceClose = 0

        End Select
    End Function

    Private Function LSA_SetRemote(ByRef addr As Integer, ByRef rMode As Integer) As Integer

        Select Case (IF_Sel)
            Case IF_USB
                LSA_SetRemote = USB488_SetRemote(addr, rMode)

            Case IF_COM1
                LSA_SetRemote = 0

        End Select
    End Function

    Private Function LSA_Send(ByRef addr As Integer, ByRef strBuf As String) As Integer

        Select Case (IF_Sel)
            Case IF_USB
                LSA_Send = USB488_Send(addr, strBuf + vbLf)

            Case IF_COM1
                SerialPort1.DiscardInBuffer()
                SerialPort1.WriteLine(strBuf)
                LSA_Send = Len(strBuf)
        End Select
    End Function

    Private Function LSA_Recive(ByRef addr As Integer, ByRef Count As Integer, ByRef strBuf As String) As Integer
        strBuf = Space(Count + 1)
        Sleep(200)
        Select Case (IF_Sel)
            Case IF_USB
                LSA_Recive = USB488_Receive(addr, Count, strBuf)
                If LSA_Recive > 0 Then
                    strBuf = Strings.Left(strBuf, LSA_Recive)
                End If

            Case IF_COM1
                strBuf = SerialPort1.ReadExisting
                LSA_Recive = Len(strBuf)
        End Select
    End Function



End Class
